//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_peek.c 394 2007-03-05 03:40:13Z ingo $

#include <hpgcc3.h>
#include <master_globals.h>

unsigned int sat3_peek(SAT_OBJECT sataddr,int nibbles)
{
    
    // GENERAL PEEK ROUTINE, UP TO 8 NIBBLES

    LONGLONG *ptr=(LONGLONG *)(sat3_s2a(sataddr)&0xfffffffc);	

    unsigned mask;
    int rot=(sataddr&7)<<2;
    
    mask=1<<(nibbles<<2);
    mask--;

return (unsigned)( (unsigned int)((*ptr)>>rot))&mask;
}
