//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <hpgcc3.h>

// REWRITTEN BY CLAUDIO 02-09-05

char *
ulltoa(ULONGLONG z, char * buff, int base)
{
// CHANGED BY CLAUDIO - MAR 2006

/*
ULONGLONG powers[64],*ptr=powers;
ULONGLONG pw=1;
char *ret=buff;
int digit;
// GENERATE LIST OF POWERS OF THE BASE
do {
*ptr=pw;
++ptr;
// DETECT OVERFLOW!
if( ((pw>>32)*base) >> 32 ) break;
pw*=base;
} while(pw<=z);

for(--ptr;ptr>=powers;ptr--)
{
    digit=0;
    while(z>=*ptr) { ++digit; z-=*ptr; }
    *buff= (digit>9)? (digit+87) : (digit+48) ;
    ++buff;
}

*buff=0;
return ret;
*/

XREAL xr;
struct conversion_data data;
data.flags=0;
data.base=base;
data.type=2;
data.width=data.precision=0;
xr_ullong2xr(z,&xr);
if(data.base==10) xr_base10(&xr,&xr);
char *ptr=xr_xrtoa(&xr,&data);
strcpy(buff,ptr);
free(ptr);
return buff;
}


char *lltoa(LONGLONG z, char *buff, int base)
{
    char *ret=buff;
    if(z<0) { *buff='-'; ++buff; z=-z; }
    ulltoa(z,buff,base);
    return ret;

}

// ORIGINAL INGO'S CODE
/*
#define N 64


char *
ulltoa(ULONGLONG z, char *t, int base)
{
    
    char *dig = "0123456789ABCDEFEFGHIJKLMNOPQRSTUVWXYZ";
    char buf[N+1];
    int i;
    
    memset(buf,0,N+1);
    i = N-1;
    buf[i] = '0';
    
    
    if(z) {
        
        do {
            unsigned rem;
            
            z = udiv64(z,(unsigned long) base, &rem);
            buf[i--] = dig[rem];
        } while(z && i);
        i++;
    }
    
    
    return strcpy(t,&buf[i]);
}


char *
lltoa(LONGLONG z, char *t, int base)
{
    
    
    int minus;
    char buf[N+1];
    char mbuf[N+2];
    
    
    if ((minus = (z < 0))) {
        z = -z;
        strcpy(mbuf,"-");
    }
    
    ulltoa(z,buf,base);
            
    return minus ? strcpy(t,strcat(mbuf,buf)) : strcpy(t,buf);
}
*/

